;                          A/D.ASM
;
;               PIC A/D Demonstration
;      Measures the settings of four potentiometers
;               and displays the values in BCD on LCD display
; -------------------------------------------------------------------------

AtoD            bsf     STATUS,RP0              ; Select page 1
                movlw   B'00000000'             ; select all analog inputs
                movwf   ADCON0                  ; (actually is ADCON1 reg in page 1)
                bcf     STATUS,RP0              ; back to page 0

; get first reading

AtoD01          movlw   B'00000001'             ; Select input from Ra0
                movwf   ADCON0
                movlw   H'00'                   ; point to top left of LCD
                call    Position                ; (note: This also gives the A/D input
                                                ;        a little time to settle down)
                call    Volt                    ; get reading from potentiometer
                call    BinBCD                  ; convert to Decimal
                call    Dec_Out                 ; and display it

; get 2nd reading

                movlw   B'00001001'             ; select input from Ra1
                movwf   ADCON0
                movlw   D'64'                   ; point to lower left of LCD
                call    Position
                call    Volt                    ; get reading from potentiometer
                call    BinBCD                  ; convert to Decimal
                call    Dec_Out                 ; and display it

; get 3rd reading

                movlw   B'00010001'             ; select input from Ra2
                movwf   ADCON0
                movlw   D'77'                   ; point to lower right of LCD
                call    Position
                call    Volt                    ; get reading from potentiometer
                call    BinBCD                  ; convert to Decimal
                call    Dec_Out                 ; and display it

; get 4th reading

                movlw   B'00011001'             ; select input from Ra3
                movwf   ADCON0
                movlw   D'13'                   ; point to top right of LCD
                call    Position
                call    Volt                    ; get reading from potentiometer
                call    BinBCD                  ; convert to Decimal
                call    Dec_Out                 ; and display it

                goto    AtoD01

; -------------------------------------------------------------------------

Volt            bsf     ADCON0,GO               ; start the conversion
Volt01          btfsc   ADCON0,GO               ; Is conversion finished yet?
                goto    Volt01                  ; no, try again
                movf    ADRES,W                 ; yes, get the reading
                return

; ---------------------------------------------------------------------------

